/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rtabmap-ros-0.8.12-0raring-20150806-0238/msg/NodeData.msg
 *
 */


#ifndef RTABMAP_ROS_MESSAGE_NODEDATA_H
#define RTABMAP_ROS_MESSAGE_NODEDATA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <rtabmap_ros/UserData.h>
#include <geometry_msgs/Pose.h>
#include <geometry_msgs/Transform.h>
#include <rtabmap_ros/KeyPoint.h>
#include <sensor_msgs/PointCloud2.h>

namespace rtabmap_ros
{
template <class ContainerAllocator>
struct NodeData_
{
  typedef NodeData_<ContainerAllocator> Type;

  NodeData_()
    : id(0)
    , mapId(0)
    , weight(0)
    , stamp(0.0)
    , label()
    , userData()
    , pose()
    , image()
    , depth()
    , fx(0.0)
    , fy(0.0)
    , cx(0.0)
    , cy(0.0)
    , laserScan()
    , localTransform()
    , wordIds()
    , wordKpts()
    , wordPts()  {
    }
  NodeData_(const ContainerAllocator& _alloc)
    : id(0)
    , mapId(0)
    , weight(0)
    , stamp(0.0)
    , label(_alloc)
    , userData(_alloc)
    , pose(_alloc)
    , image(_alloc)
    , depth(_alloc)
    , fx(0.0)
    , fy(0.0)
    , cx(0.0)
    , cy(0.0)
    , laserScan(_alloc)
    , localTransform(_alloc)
    , wordIds(_alloc)
    , wordKpts(_alloc)
    , wordPts(_alloc)  {
    }



   typedef int32_t _id_type;
  _id_type id;

   typedef int32_t _mapId_type;
  _mapId_type mapId;

   typedef int32_t _weight_type;
  _weight_type weight;

   typedef double _stamp_type;
  _stamp_type stamp;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _label_type;
  _label_type label;

   typedef  ::rtabmap_ros::UserData_<ContainerAllocator>  _userData_type;
  _userData_type userData;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _image_type;
  _image_type image;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _depth_type;
  _depth_type depth;

   typedef float _fx_type;
  _fx_type fx;

   typedef float _fy_type;
  _fy_type fy;

   typedef float _cx_type;
  _cx_type cx;

   typedef float _cy_type;
  _cy_type cy;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _laserScan_type;
  _laserScan_type laserScan;

   typedef  ::geometry_msgs::Transform_<ContainerAllocator>  _localTransform_type;
  _localTransform_type localTransform;

   typedef std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other >  _wordIds_type;
  _wordIds_type wordIds;

   typedef std::vector< ::rtabmap_ros::KeyPoint_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::rtabmap_ros::KeyPoint_<ContainerAllocator> >::other >  _wordKpts_type;
  _wordKpts_type wordKpts;

   typedef  ::sensor_msgs::PointCloud2_<ContainerAllocator>  _wordPts_type;
  _wordPts_type wordPts;




  typedef boost::shared_ptr< ::rtabmap_ros::NodeData_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rtabmap_ros::NodeData_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct NodeData_

typedef ::rtabmap_ros::NodeData_<std::allocator<void> > NodeData;

typedef boost::shared_ptr< ::rtabmap_ros::NodeData > NodeDataPtr;
typedef boost::shared_ptr< ::rtabmap_ros::NodeData const> NodeDataConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rtabmap_ros::NodeData_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rtabmap_ros::NodeData_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rtabmap_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'rtabmap_ros': ['/tmp/buildd/ros-hydro-rtabmap-ros-0.8.12-0raring-20150806-0238/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rtabmap_ros::NodeData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rtabmap_ros::NodeData_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rtabmap_ros::NodeData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rtabmap_ros::NodeData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rtabmap_ros::NodeData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rtabmap_ros::NodeData_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rtabmap_ros::NodeData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0720677181617903685d803fe2c3c048";
  }

  static const char* value(const ::rtabmap_ros::NodeData_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0720677181617903ULL;
  static const uint64_t static_value2 = 0x685d803fe2c3c048ULL;
};

template<class ContainerAllocator>
struct DataType< ::rtabmap_ros::NodeData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rtabmap_ros/NodeData";
  }

  static const char* value(const ::rtabmap_ros::NodeData_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rtabmap_ros::NodeData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
int32 id\n\
int32 mapId\n\
int32 weight\n\
float64 stamp\n\
string label\n\
UserData userData\n\
\n\
# Pose from odometry not corrected\n\
geometry_msgs/Pose pose\n\
\n\
# compressed image in /camera_link frame\n\
# use rtabmap::util3d::uncompressImage() from \"rtabmap/core/util3d.h\"\n\
uint8[] image\n\
\n\
# compressed depth image in /camera_link frame\n\
# use rtabmap::util3d::uncompressImage() from \"rtabmap/core/util3d.h\"\n\
uint8[] depth\n\
\n\
float32 fx\n\
float32 fy\n\
float32 cx\n\
float32 cy\n\
\n\
# compressed 2D laser scan in /base_link frame\n\
# use rtabmap::util3d::uncompressData() from \"rtabmap/core/util3d.h\"\n\
uint8[] laserScan\n\
\n\
# local transform (/base_link -> /camera_link)\n\
geometry_msgs/Transform localTransform\n\
\n\
\n\
# std::multimap<wordId, cv::Keypoint>\n\
# std::multimap<wordId, pcl::PointXYZ>\n\
int32[] wordIds\n\
KeyPoint[] wordKpts\n\
sensor_msgs/PointCloud2 wordPts\n\
================================================================================\n\
MSG: rtabmap_ros/UserData\n\
\n\
uint8[] data\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Transform\n\
# This represents the transform between two coordinate frames in free space.\n\
\n\
Vector3 translation\n\
Quaternion rotation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: rtabmap_ros/KeyPoint\n\
#class cv::KeyPoint\n\
#{\n\
#    Point2f pt;\n\
#    float size;\n\
#    float angle;\n\
#    float response;\n\
#    int octave;\n\
#    int class_id;\n\
#}\n\
\n\
Point2f pt\n\
float32 size\n\
float32 angle\n\
float32 response\n\
int32 octave\n\
int32 class_id\n\
================================================================================\n\
MSG: rtabmap_ros/Point2f\n\
#class cv::Point2f\n\
#{\n\
#    float x;\n\
#    float y;\n\
#}\n\
\n\
float32 x\n\
float32 y\n\
================================================================================\n\
MSG: sensor_msgs/PointCloud2\n\
# This message holds a collection of N-dimensional points, which may\n\
# contain additional information such as normals, intensity, etc. The\n\
# point data is stored as a binary blob, its layout described by the\n\
# contents of the \"fields\" array.\n\
\n\
# The point cloud data may be organized 2d (image-like) or 1d\n\
# (unordered). Point clouds organized as 2d images may be produced by\n\
# camera depth sensors such as stereo or time-of-flight.\n\
\n\
# Time of sensor data acquisition, and the coordinate frame ID (for 3d\n\
# points).\n\
Header header\n\
\n\
# 2D structure of the point cloud. If the cloud is unordered, height is\n\
# 1 and width is the length of the point cloud.\n\
uint32 height\n\
uint32 width\n\
\n\
# Describes the channels and their layout in the binary data blob.\n\
PointField[] fields\n\
\n\
bool    is_bigendian # Is this data bigendian?\n\
uint32  point_step   # Length of a point in bytes\n\
uint32  row_step     # Length of a row in bytes\n\
uint8[] data         # Actual point data, size is (row_step*height)\n\
\n\
bool is_dense        # True if there are no invalid points\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: sensor_msgs/PointField\n\
# This message holds the description of one point entry in the\n\
# PointCloud2 message format.\n\
uint8 INT8    = 1\n\
uint8 UINT8   = 2\n\
uint8 INT16   = 3\n\
uint8 UINT16  = 4\n\
uint8 INT32   = 5\n\
uint8 UINT32  = 6\n\
uint8 FLOAT32 = 7\n\
uint8 FLOAT64 = 8\n\
\n\
string name      # Name of field\n\
uint32 offset    # Offset from start of point struct\n\
uint8  datatype  # Datatype enumeration, see above\n\
uint32 count     # How many elements in the field\n\
";
  }

  static const char* value(const ::rtabmap_ros::NodeData_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rtabmap_ros::NodeData_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.id);
      stream.next(m.mapId);
      stream.next(m.weight);
      stream.next(m.stamp);
      stream.next(m.label);
      stream.next(m.userData);
      stream.next(m.pose);
      stream.next(m.image);
      stream.next(m.depth);
      stream.next(m.fx);
      stream.next(m.fy);
      stream.next(m.cx);
      stream.next(m.cy);
      stream.next(m.laserScan);
      stream.next(m.localTransform);
      stream.next(m.wordIds);
      stream.next(m.wordKpts);
      stream.next(m.wordPts);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct NodeData_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rtabmap_ros::NodeData_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rtabmap_ros::NodeData_<ContainerAllocator>& v)
  {
    s << indent << "id: ";
    Printer<int32_t>::stream(s, indent + "  ", v.id);
    s << indent << "mapId: ";
    Printer<int32_t>::stream(s, indent + "  ", v.mapId);
    s << indent << "weight: ";
    Printer<int32_t>::stream(s, indent + "  ", v.weight);
    s << indent << "stamp: ";
    Printer<double>::stream(s, indent + "  ", v.stamp);
    s << indent << "label: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.label);
    s << indent << "userData: ";
    s << std::endl;
    Printer< ::rtabmap_ros::UserData_<ContainerAllocator> >::stream(s, indent + "  ", v.userData);
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "image[]" << std::endl;
    for (size_t i = 0; i < v.image.size(); ++i)
    {
      s << indent << "  image[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.image[i]);
    }
    s << indent << "depth[]" << std::endl;
    for (size_t i = 0; i < v.depth.size(); ++i)
    {
      s << indent << "  depth[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.depth[i]);
    }
    s << indent << "fx: ";
    Printer<float>::stream(s, indent + "  ", v.fx);
    s << indent << "fy: ";
    Printer<float>::stream(s, indent + "  ", v.fy);
    s << indent << "cx: ";
    Printer<float>::stream(s, indent + "  ", v.cx);
    s << indent << "cy: ";
    Printer<float>::stream(s, indent + "  ", v.cy);
    s << indent << "laserScan[]" << std::endl;
    for (size_t i = 0; i < v.laserScan.size(); ++i)
    {
      s << indent << "  laserScan[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.laserScan[i]);
    }
    s << indent << "localTransform: ";
    s << std::endl;
    Printer< ::geometry_msgs::Transform_<ContainerAllocator> >::stream(s, indent + "  ", v.localTransform);
    s << indent << "wordIds[]" << std::endl;
    for (size_t i = 0; i < v.wordIds.size(); ++i)
    {
      s << indent << "  wordIds[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.wordIds[i]);
    }
    s << indent << "wordKpts[]" << std::endl;
    for (size_t i = 0; i < v.wordKpts.size(); ++i)
    {
      s << indent << "  wordKpts[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::rtabmap_ros::KeyPoint_<ContainerAllocator> >::stream(s, indent + "    ", v.wordKpts[i]);
    }
    s << indent << "wordPts: ";
    s << std::endl;
    Printer< ::sensor_msgs::PointCloud2_<ContainerAllocator> >::stream(s, indent + "  ", v.wordPts);
  }
};

} // namespace message_operations
} // namespace ros

#endif // RTABMAP_ROS_MESSAGE_NODEDATA_H
